; ---------------------------------- INFO --------------------------------------
;                                EMULADOR V1.1
;       INTEGRANTES: JORGE A. QUIROGA, MIGUEL MC ALLISTER, MAURICIO GOMEZ
; ------------------------------------------------------------------------------

.586
.MODEL FLAT, STDCALL
option casemap:none

.SALL
.NOLIST

; ----- Los INCLUDE son necesarios para que funcionen las utilidades proporcionadas -----
INCLUDE \masm32\include\windows.inc
INCLUDE \masm32\include\kernel32.inc
INCLUDE \masm32\include\user32.inc
INCLUDE \masm32\include\masm32.inc

include \masm32\include\debug.inc
includelib \masm32\lib\debug.lib

INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\masm32.lib

.LIST

.DATA   ; ------------- A CONTINUACIN DECLARARE VARIABLES INICIALIZADAS -------------

bytesLeidos DWORD 0
pc DWORD 0

; -------------------------- FIN DE VARIABLES INICIALIZADAS --------------------------


.DATA?  ; ------------ A CONTINUACIN DECLARARE VARIABLES SIN INICIALIZAR ------------


archivo DWORD ?
registros WORD 16 DUP(?)
memoria BYTE 65536 DUP(?) ; 2^16=64K

nombreArchivo DWORD ?
tamanhoPrograma DWORD ?
posicionPrograma WORD ?
modoDeDireccionamiento BYTE ?

buffer16 WORD ?
primerOperando BYTE ?
segundoOperando BYTE ?
codOp BYTE ?
constanteDeOperacion WORD ?

; ------------------------- FIN DE VARIABLES SIN INICIALIZAR -------------------------



.CONST  ; -------------------- A CONTINUACIN DECLARARE CONSTANTES -------------------

;Strings mensajes
MENSAJE1 byte "Por favor ingrese el nombre del archivo de entrada:" , CR, LF, 0
MODO_DIRECCIONAMIENTO byte "Modo de direccionamiento:" , CR, LF, 0
PRIMER_OP byte "Primero operando:" , CR, LF, 0
SEGUNDO_OP byte "Segundo operando:" , CR, LF, 0
ERROR byte "Error" , CR, LF, 0
OPERACION byte "Operacion:" , CR, LF, 0
MAL_ARCHIVO byte "No se puede abrir el archivo", CR, LF, 0
EL_PC_QUEDO_EN byte "El PC quedo en : " , CR, LF, 0 
ESPACIO byte " ",CR,LF,0
FINALIZAR byte "finalizar",0

;Strings modo de direccionamiento
    REGISTRO byte "Registro" , CR, LF, 0
    INDIRECTO_POR_REGISTRO byte "Indirecto por registro" , CR, LF, 0
    INMEDIATO byte "Inmediato" , CR, LF, 0
    DIRECTO byte "Directo" , CR, LF, 0
    
;Strings operaciones
    MOVER byte "Mover" , CR, LF, 0
    GUARDAR byte "Guardar en memoria" , CR, LF, 0
    SUMAR byte "Sumar" , CR, LF, 0
    NAND byte "Nand" , CR, LF, 0
    SHIFT byte "Shift" , CR, LF, 0
    MENOR_QUE byte "Menor que" , CR, LF, 0
    SALTO_COND byte "Salto condicional" , CR, LF, 0
    SALTO_INCOND byte "Salto incondicional" , CR, LF, 0
    DETENER byte "Detener" , CR, LF, 0
; --------------------------------- FIN DE CONSTANTES --------------------------------




.CODE  ; ----------------------- A CONTINUACIN VIENE EL CDIGO ----------------------

; El siguiente include tiene las utilidades proporcionadas.
; Para ver en qu consisten, puede leer el archivo "utilidades.inc".
   INCLUDE utilidades.inc

; ------------------------------ ATENCIN ------------------------------
; El API de windows preserva los registros ebx, ebp, esi, edi.
; No preserva los registros ecx y edx. Si usa estos registros, slvelos antes de llamar
; funciones del API de windows.
; El API usa eax para retornar valores y, en consecuencia, tampoco lo preserva.
; ----------------------------------------------------------------------
; En un invoke, para pasar como parmetro la direccin de una variable (un apuntador a la
; variable) y no su valor, se debe escribir ADDR nombre-variable

   principal PROC USES ebx ebp esi edi  ;-- A CONTINUACIN ESCRIBA EL PROGRAMA PRINCIPAL

    ;Pide el nombre del archivo de entrada
    ;Llama a leerPrograma, y despus a escribirPrograma.

    invoke StdOut, ADDR MENSAJE1
    invoke StdIn, ADDR nombreArchivo, 22    
    
    push offset nombreArchivo
    push offset memoria
    call leerPrograma
    add esp,8
    
    push posicionPrograma
    push offset memoria
    push tamanhoPrograma

    call ejecutarPrograma 
    add esp,12
    call imprimirResultado


      ;--------------  RETORNO A WINDOWS, FIN DEL PROGRAMA PRINCIPAL ------------------
      invoke ExitProcess, NULL  ;Cdigo de retorno; 0 = terminacin normal

   principal ENDP

; ------------- A CONTINUACIN ESCRIBA LAS SUBRUTINAS -------------

;************************************************************************
;*****************************LEER PROGRAMA******************************
;*****Lee el programa que esta en el archivo y lo carga a la memoria*****
;*
;*@param un apuntador al nombre del archivo (una cadena de caracteres con formato C) 
;*@param un apuntador al vector donde se simula la memoria.
;************************************************************************
leerPrograma PROC

    mov ebp,esp
    push ebp
    
    mov ebx,[ebp+4] ; memoria
    mov edi, [ebp+8]; nombreArchivo
        
;El archivo debe existir; si no, reporta error.
    invoke openFile, addr nombreArchivo, ( GENERIC_READ OR GENERIC_WRITE ), OPEN_EXISTING

    cmp eax, INVALID_HANDLE_VALUE  ;Error al abrir el archivo

     jne leerEscribir
     mov eax, offset MAL_ARCHIVO
     jmp imprimirError

;Leemos el programa
    leerEscribir:

     mov archivo, eax  
     invoke SetFilePointer, archivo, 0, NULL, FILE_BEGIN             ; Guardar apuntador a descriptor del archivo	                                               

     invoke ReadFile, archivo, addr posicionPrograma,2,addr bytesLeidos, NULL    ; leemos la posicion del programa con respecto al vector memoria	
     mov ecx,0
     mov cx,posicionPrograma
     add ebx,ecx
     mov pc, ebx ; le asigna al pc la direccion de memoria de la primera instruccion


     invoke ReadFile, archivo, addr buffer16,2,addr bytesLeidos, NULL 
     mov cx, buffer16
     
     bswap ecx          ;Hace swap para pasar a big endian
     shr ecx, 16        ;Shift 16 a la derecha para dejar lo que nos interesa en cx.
     mov buffer16, cx   ;Reemplaza el valor de buffer16 por su valor intercambiado.

    
;El ciclo de lectura

    mov esi,0           ;Limpia el registro esi donde se guardar el tamao del programa
 cicloLectura:
 
     AND ch,11111100B        
     cmp ch,00100000B
      je detenerCiclo

     mov cx, buffer16
     AND ch,00000011B
     cmp ch,00000001B           
      je copiarWord
     cmp ch,00000000B
      je copiarWord
      jmp copiarDWord

  copiarDWord:
  
      mov edi, 0 
      mov eax, 0 
      mov di,buffer16                                                                ;Despues de verificar el modo de direccinamiento del registro agregamos en memoria 
                                                                                      ;la instruccion con el tamao correspondiente
      invoke ReadFile, archivo, addr buffer16,2,addr bytesLeidos, NULL    

      mov ax,buffer16

      bswap eax          ;Hace swap para pasar a big endian
      shr eax, 16        ;Shift 16 a la derecha para dejar lo que nos interesa en cx.
     mov buffer16, ax   ;Reemplaza el valor de buffer16 por su valor intercambiado.

      mov ax,buffer16  
        
      shl eax, 16
      shr eax, 16

     ;shl edi, 16

 ;or eax, edi  


           
      mov [ebx],di
        add ebx,2
        mov [ebx],ax
      
      add esi,4
      add ebx,2
		
      invoke ReadFile, archivo, addr buffer16,2,addr bytesLeidos, NULL 

      mov cx, buffer16
      bswap ecx          ;Hace swap para pasar a big endian
      shr ecx, 16        ;Shift 16 a la derecha para dejar lo que nos interesa en cx.
      mov buffer16, cx   ;Reemplaza el valor de buffer16 por su valor intercambiado.
    
      mov cx, buffer16
  	jmp cicloLectura
		
  copiarWord:
  
      mov cx,buffer16
      mov word ptr [ebx],cx
       
       	add ebx,2
      add esi,2
      invoke ReadFile, archivo, addr buffer16,2,addr bytesLeidos, NULL 	
      mov cx, buffer16

      bswap ecx          ;Hace swap para pasar a big endian
      shr ecx, 16        ;Shift 16 a la derecha para dejar lo que nos interesa en cx.
      mov buffer16, cx   ;Reemplaza el valor de buffer16 por su valor intercambiado.
      
      jmp cicloLectura
	
detenerCiclo:
    mov tamanhoPrograma,esi               
    jmp finLeerPrograma

imprimirError:
    push eax	
    invoke StdOut, addr ERROR
    pop eax
    invoke StdOut, eax	   

finLeerPrograma:
pop ebp
ret
      
leerPrograma ENDP


;************************************************************************
;***************************EJECUTAR PROGRAMA****************************
;*******Recorre el programa y ejecuta cada instruccin*******
;*
;*@param Un apuntador al vector que simula a la memoria,
;*@param La posicin donde se carg programa
;*@param El tamao del programa
;************************************************************************
ejecutarPrograma PROC

    mov ebp,esp
    push ebp
    
    mov ebx,[ebp+4] ;tamanhoPrograma
    mov eax,[ebp+8] ;memoria
    mov edx,[ebp+12]; posicionPrograma

    shl edx, 16
    shr edx, 16

    ;TRAER LA INSTRUCCION APUNTADA POR EL PC
    ;INCREMENTARLO SEGUN EL TAMAO DE LA INSTRUCCION(ciclo de lectura)
    ;DECODIFICARLA (DETERMINAR SU COP.OP, MODO DE DIRECC Y SUS OPERANDOS)
    ;EJECUTARLA
    ;HASTA ENCONTRARSE CON LA INSTRUCCION "DETENER"

    ;Iniciamos el ciclo de lectura
	CicloLectura:         

           
	       cmp ebx ,0
             je finEscribirPrograma
 
             mov ecx, pc 
             mov eax,[ecx]
                  
         
         
         
        	 and ah,00000011B
        	 cmp ah,00000001B
        	  je leerWord	  
        	 cmp ah,00000000B
        	  je leerWord
        	 jmp leerDword

        	 leerWord:
        
        	   mov eax, [ecx]            ; eax = lo apuntado por el PC
        

           push eax
               call instruccionWORD
                     add esp,4
            
                add pc, 2   
        	   sub ebx,2
                   
          jmp CicloLectura

        	leerDword:
          
               mov eax,[ecx]               ;En eax est la instruccin completa

               rol eax,16

               push eax
               
               call instruccionDWORD
            
                
        	   add esp,4

                 add pc, 4        	  
                 sub ebx,4
         
        
        jmp CicloLectura


    finEscribirPrograma:
      pop ebp
      ret

ejecutarPrograma ENDP

;************************************************************************
;************************Instruccin ejecutar WORD***********************
;*Analiza e imprime los datos que hay en la parte alta de la instruccin*
;*
;*@param el La parte alta de la instruccion : WORD
;************************************************************************
instruccionWORD PROC

        mov ebp,esp
        push ebp
        push ebx
        
        mov ebx,[ebp+4] ; La parte alta de la instruccin
	  mov ax, bx ; Se copia para alterar al y dejar el original en ax 
           
        ;Partir bx en : cod.op , modo direccionamiento, 1er op, 2do op

        ;SACAR E IMPRIMIR CDIGO DE OPERACION
                shr ah, 2
                mov codOp, ah
           
        ;SACAR E IMPRIMIR PRIMER OPERANDO
                mov ax,bx
                shr al, 4
             
                mov primerOperando, al
                
        ;SACAR E IMPRIMIR SEGUNDO OPERANDO
                mov ax,bx
                shl al, 4
                shr al, 4
            
                mov segundoOperando, al
                
        ;SACAR E IMPRIMIR MODO DE DIRECCIONAMIENTO
                mov ax,bx
                shl ah,6
                shr ah,6

                and ah, 00000011B
                
                cmp ah, 00000000B
                je registro
                cmp ah, 00000001
                je indirectoPorRegistro
    
        registro:
        ; Limpiamos los registros
         mov eax, 0
         mov ebx, 0
         mov ecx, 0
         
         mov al, codOp
         push eax
         mov bl, segundoOperando 
         push ebx
         mov cl, primerOperando
         push ecx 
         
         call ejecutarPorRegistro
         add esp,12
         jmp finleerParteAltaInstruccion
         
        indirectoPorRegistro:
         mov eax, 0
         mov ebx, 0
         mov ecx, 0
         
         mov al, codOp
         push eax
         mov bl, segundoOperando 
         push ebx
         mov cl, primerOperando
         push ecx 
         
         call ejecutarPorIndirecto
         add esp,12
         jmp finleerParteAltaInstruccion
              

    finleerParteAltaInstruccion:
      pop ebx
      pop ebp
      
      ret


instruccionWORD ENDP

;************************************************************************
;************************Instruccin ejecutar DWORD**********************
;*Analiza e imprime los datos que hay en la parte alta de la instruccin*
;*
;*@param el La parte alta de la instruccion : DWORD
;************************************************************************
instruccionDWORD PROC

        mov ebp,esp
        push ebp
        push ebx
        mov ebx,[ebp+4] 
         
        mov eax, ebx    ; Se copia la intruccin original en eax para no daarla
        shr eax, 26
        mov codOp, al


        mov eax, ebx    ; Se copia la intruccin original en eax para no daarla
        shl eax, 8
        shr eax, 20
        mov primerOperando, ah
        
        mov eax, ebx    ; Se copia la intruccin original en eax para no daarla
        mov constanteDeOperacion, ax
        mov eax, ebx    ; Se copia la intruccin original en eax para no daarla     
        shl eax, 6
        shr eax, 30  
        mov modoDeDireccionamiento , al
                ;SACAR E IMPRIMIR MODO DE DIRECCIONAMIENTO

                and al, 00000011B
                cmp al, 00000010B
                je inmediato
                cmp al, 00000011B
                je directo
    
        inmediato:
        ;Limpiamos los registros
         mov eax, 0
         mov ebx, 0
         mov ecx, 0
         
         mov al, codOp
         push eax
         mov bx, constanteDeOperacion
         
         push ebx
         mov cl, primerOperando
         push ecx 
         
         call ejecutarPorInmediato
         add esp,12

         jmp finInstruccionDWORD 
         
        directo:
        ;Limpiamos los registros
         mov eax, 0
         mov ebx, 0
         mov ecx, 0
         
         mov al, codOp
         push eax
         mov bl, segundoOperando 
         push ebx
         mov cl, primerOperando
         push ecx 
         
         call ejecutarPorDirecto
         add esp,12

         jmp finInstruccionDWORD 
         
    finInstruccionDWORD :
    pop ebx
    pop ebp
        ret
        
instruccionDWORD ENDP

;************************************************************************
;***************************EJECUTAR POR REGISTRO ***********************
;***Ejecuta la instruccion, esta tiene direccionamiento por registro ****
;*
;***********************************************************************
ejecutarPorRegistro PROC

 mov ebp,esp
 push ebp

 mov eax,[ebp+4]; eax=primerOperando
 mov ebx,[ebp+8]; ebx=segundoOperando
 mov ecx,[ebp+12]; ecx=codOp
 mov edx,0


and cl, 00001111B 

;leemos el codigo de instruccion y agregamos el valor que corresponde
    cmp cl, 00000000B
        je mover
    cmp cl, 00000001B
        je guardarEnMemoria
    cmp cl, 00000010B
        je sumar
    cmp cl, 00000011B
        je nand
    cmp cl, 00000100B
        je shift
    cmp cl, 00000101B
        je menorQue
    cmp cl, 00000110B
        je saltoCond
    cmp cl, 00000111B
        je saltoIncond
    cmp cl, 00001000B
        je detener  

    mover:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]

        mov registros[eax*2], dx
        
        
        jmp finEjecutarPorRegistro 
    
    guardarEnMemoria:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]

        mov registros[ebx*2], cx

        jmp finEjecutarPorRegistro 
    
    sumar:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]
        add cx,dx
        mov registros[eax*2], cx

        jmp finEjecutarPorRegistro 
    
    nand:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]
        and cx,dx
        not cx
        mov registros[eax*2], cx

        jmp finEjecutarPorRegistro 
        
    shift:
        mov dx, registros[eax*2]
        mov cx, registros[ebx*2]

        cmp cx, 0
        jg mayorQueCero1

        shr dx, cl

        mayorQueCero1:
            shl dx, cl

        mov registros[eax*2], dx
        
        jmp finEjecutarPorRegistro 
        
    menorQue:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]

        cmp cx, dx
        jg mayorQueCero2

        mov registros[eax*2],1

        mayorQueCero2:
            mov registros[eax*2],0
        
        jmp finEjecutarPorRegistro 
        
    saltoCond:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]

        and cx,1
        cmp cx, 1
        je tieneUnUno1
        jmp fin
        
    tieneUnUno1:
        mov pc, edx

    fin:
        jmp finEjecutarPorRegistro 
        
    saltoIncond:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]

        mov ecx, pc
        add cx,1
        mov registros[eax*2], cx
        mov pc, edx

        jmp finEjecutarPorRegistro 
    
    detener:
        jmp finEjecutarPorRegistro 

    finEjecutarPorRegistro:
        pop ebp
        ret
      
ejecutarPorRegistro ENDP


;************************************************************************
;*************************EJECUTAR POR INDIRECTO*************************
;***Ejecuta la instruccion con direccionamiento indirecto por registro***
;*
;@param primerOperando
;@param segundoOperando
;@param codigoDeOperacion
;***********************************************************************
ejecutarPorIndirecto PROC

 mov ebp,esp
 push ebp

 mov eax,[ebp+4]; eax=primerOperando
 mov ebx,[ebp+8]; ebx=segundoOperando
 mov ecx,[ebp+12]; ecx=codOp
 mov edx, 0

and cl, 00001111B 

;leemos el codigo de instruccion y agregamos el valor que corresponde
    cmp cl, 00000000B
        je mover
    cmp cl, 00000001B
        je guardarEnMemoria
    cmp cl, 00000010B
        je sumar
    cmp cl, 00000011B
        je nand
    cmp cl, 00000100B
        je shift
    cmp cl, 00000101B
        je menorQue
    cmp cl, 00000110B
        je saltoCond
    cmp cl, 00000111B
        je saltoIncond
    cmp cl, 00001000B
        je detener  

    mover:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]

        mov cx, [edx]
        mov registros[eax*2], dx
        
        jmp finEjecutarPorIndirecto 
    
    guardarEnMemoria:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]

        mov [edx], cx
        mov dx, [edx]
        mov registros[ebx*2], dx

        jmp finEjecutarPorIndirecto 
    
    sumar:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]
        add cx,[edx]
        mov registros[eax*2], cx
        jmp finEjecutarPorIndirecto 
    
    nand:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]
        and cx,[edx]
        not cx
        mov registros[eax*2], cx

        jmp finEjecutarPorIndirecto 
        
    shift:
        mov dx, registros[eax*2]
        mov cx, registros[ebx*2]

        mov edi, [edx]
        cmp edi, 0
        jg mayorQueCero3

        mov ecx, [edx]
        shr dx, cl
        mov cx, registros[ebx*2]


        mayorQueCero3:
            mov ecx, [edx]
            shl dx, cl
            mov cx, registros[ebx*2]

        mov registros[eax*2], cx
        
        jmp finEjecutarPorIndirecto 
        
    menorQue:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]

        cmp cx, [edx]
        jg mayorQueCero4

        mov registros[eax*2],1

        mayorQueCero4:
            mov registros[eax*2],0
        
        jmp finEjecutarPorIndirecto 
        
    saltoCond:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]

        and cx, 1
        cmp cx, 1
        je tieneUnUno2
        jmp fin
        
        tieneUnUno2:
            mov ecx, [edx]
            mov pc, ecx

        fin:

        jmp finEjecutarPorIndirecto 
        
    saltoIncond:
        mov cx, registros[eax*2]
        mov dx, registros[ebx*2]

        mov ecx, pc
        add cx,1
        mov registros[eax*2], cx
        mov dx, [edx]
        mov pc, edx

        jmp finEjecutarPorIndirecto 
    
    detener:
        jmp finEjecutarPorIndirecto 

    finEjecutarPorIndirecto :
        pop ebp
        ret
      
ejecutarPorIndirecto ENDP

;************************************************************************
;***************************EJECUTAR POR INMEDIATO **********************
;*****Ejecuta la instruccion, esta tiene direccionamiento inmediato******
;*
;@param primerOperando
;@param segundoOperando
;@param codigoDeOperacion
;************************************************************************
ejecutarPorInmediato PROC

 mov ebp,esp
 push ebp

 mov eax,[ebp+4]; eax=primerOperando
 mov ebx,[ebp+8]; ebx=segundoOperando
 mov ecx,[ebp+12]; ecx=codOp
 mov edx,0



and cl, 00001111B 

;leemos el codigo de instruccion y agregamos el valor que corresponde
    cmp cl, 00000000B
        je mover
    cmp cl, 00000001B
        je guardarEnMemoria
    cmp cl, 00000010B
        je sumar
    cmp cl, 00000011B
        je nand
    cmp cl, 00000100B
        je shift
    cmp cl, 00000101B
        je menorQue
    cmp cl, 00000110B
        je saltoCond
    cmp cl, 00000111B
        je saltoIncond
    cmp cl, 00001000B
        je detener  

    mover:
        mov registros[eax*2], bx
        jmp finEjecutarPorInmediato  
    
    guardarEnMemoria:
        jmp finEjecutarPorInmediato  
    
    sumar:
        mov cx, registros[eax*2]

        add cx, bx
        mov registros[eax*2], cx

        jmp finEjecutarPorInmediato  
    
    nand:
        mov cx, registros[eax*2]
        and cx, bx
        not cx
        mov registros[eax*2],cx

        jmp finEjecutarPorInmediato  
        
    shift:
    
        mov dx, registros[eax*2]

        mov ecx, ebx
        cmp ebx, 0
        jg mayorQueCero5

        shr dx, cl

        mayorQueCero5:
        
            shl dx, cl

        mov registros[eax*2],dx
        
        jmp finEjecutarPorInmediato  
        
    menorQue:
        mov cx, registros[eax*2]

        cmp cx, bx
        jg mayorQueCero6

        mov registros[eax*2], 1

        mayorQueCero6:
            mov registros[eax*2],0
        
        jmp finEjecutarPorInmediato  
        
    saltoCond:
        mov cx, registros[eax*2]

        and cx,1
        cmp cx, 1
        je tieneUnUno3
        jmp fin
        
        tieneUnUno3:
            mov pc, ebx

        fin:
        jmp finEjecutarPorInmediato  
        
    saltoIncond:
        mov cx, registros[eax*2]

        mov ecx, pc
        add cx,1
        mov registros[eax*2], cx
        mov edx, ebx
        mov pc, edx

        jmp finEjecutarPorInmediato  
    
    detener:
        jmp finEjecutarPorInmediato  

    finEjecutarPorInmediato  :
        pop ebp
        ret
      
ejecutarPorInmediato ENDP

;************************************************************************
;***************************EJECUTAR POR DIRECTO*************************
;******Ejecuta la instruccion, esta tiene direccionamiento directo*******
;*
;***********************************************************************
ejecutarPorDirecto PROC

 mov ebp,esp
 push ebp

 mov eax,[ebp+4]; eax=primerOperando
 mov ebx,[ebp+8]; ebx=segundoOperando
 mov ecx,[ebp+12]; ecx=codOp
    mov edx,0

and cl, 00001111B 

;leemos el codigo de instruccion y agregamos el valor que corresponde
    cmp cl, 00000000B
        je mover
    cmp cl, 00000001B
        je guardarEnMemoria
    cmp cl, 00000010B
        je sumar
    cmp cl, 00000011B
        je nand
    cmp cl, 00000100B
        je shift
    cmp cl, 00000101B
        je menorQue
    cmp cl, 00000110B
        je saltoCond
    cmp cl, 00000111B
        je saltoIncond
    cmp cl, 00001000B
        je detener  

    mover:
        mov cx, [ebx]

        mov registros[eax*2], cx
        jmp finEjecutarPorDirecto
    
    guardarEnMemoria:
        mov cx,registros[eax*2]

        mov [ebx], cx
        jmp finEjecutarPorDirecto
    
    sumar:
        mov cx, registros[eax*2]

        add cx, [ebx]
        mov registros[eax*2], cx
        jmp finEjecutarPorDirecto
    
    nand:
        mov cx, registros[eax*2]
        and cx, [ebx]
        not cx
        mov registros[eax*2],cx
        jmp finEjecutarPorDirecto
        
    shift:
        mov dx, registros[eax*2]

        mov ecx, [ebx]
        cmp ecx, 0
        jg mayorQueCero7

        shr dx, cl

        mayorQueCero7:
            shl dx, cl

        mov registros[eax*2],dx
        jmp finEjecutarPorDirecto
        
    menorQue:
        mov cx, registros[eax*2]

        cmp cx, [ebx]
        jg mayorQueCero8

        mov registros[eax*2], 1

        mayorQueCero8:
            mov registros[eax*2],0
        jmp finEjecutarPorDirecto
        
    saltoCond:
        mov cx, registros[eax*2]
        and cx, 1
        cmp cx, 1
        je tieneUnUno4
        jmp fin
        
        tieneUnUno4:
            mov ebx, [ebx]
            mov pc, ebx
            

        fin:
        jmp finEjecutarPorDirecto
        
    saltoIncond:
        mov cx, registros[eax*2]

        mov ecx, pc
        add cx,1
        mov registros[eax*2], cx
        mov edx, [ebx]
        mov pc, edx
        jmp finEjecutarPorDirecto
    
    detener:
        jmp finEjecutarPorDirecto

    finEjecutarPorDirecto  :
        pop ebp
        ret
      
ejecutarPorDirecto ENDP


;************************************************************************
;***************************IMPRIMIR RESULTADO***************************
;****************Imprime el PC como queda y el valor de los************** 
;*********************registros de la mquina virtual********************
;*
;***********************************************************************
imprimirResultado PROC

    mov ebp,esp
    mov esi, 0
    mov ebx, 0
    cicloRegistros:

        cmp esi, 32
        je finCiclo

        mov bx, registros[esi]
        invoke printNumber,10,bx
        PrintHex bx
        invoke StdOut, ADDR ESPACIO
        add esi,1
       jmp cicloRegistros
    
    finCiclo:
    PrintDec pc
    mov esp,ebp
    invoke StdOut,ADDR pc
    ret

imprimirResultado ENDP

; ------------- FIN DE LAS SUBRUTINAS, FIN DEL CDIGO -------------
END principal
