.486
.MODEL FLAT, STDCALL
option casemap:none

.SALL
.NOLIST

; ----- INCLUDE del API de Windows -----
INCLUDE \masm32\include\windows.inc
INCLUDE \masm32\include\kernel32.inc
INCLUDE \masm32\include\user32.inc
INCLUDE \masm32\include\masm32.inc

INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\masm32.lib

.LIST

;------------------ DECLARACIONES ------------------
  
.DATA

  
.DATA?

  archivo dword ?
  bytesLeidos dword ?
  basura dword ?
  bufferIO byte 5 dup ( ? )
  
.CONST

  NOMBRE_ARCHIVO byte "Se creara: ""hola.txt"" ", CR, LF, 0
  ARCHIVO_OK byte "hola.txt creado", CR, LF, 0
  MIRAR_ARCHIVO byte "Antes de continuar, mire el archivo ""hola.txt""", CR, LF
                byte "Debe decir ""Hola Mundo"".", CR, LF
                byte "Teclee <enter> cuando haya terminado.", CR, LF, 0

  nombreArchivo byte "hola.txt", 0
  HOLA byte "Hola mundo"   ;Note que no est en convencin C
	ERROR  byte  "***ERROR: ",0
  MAL_ARCHIVO byte "No se puede abrir el archivo", CR, LF, 0
  
.CODE

  INCLUDE utilidades.inc

; ------------------------------ ATENCIN ------------------------------
; El API de windows preserva los registros ebx, ebp, esi, edi.
; No preserva los registros ecx y edx. Si usa estos registros, slvelos antes de llamar
; funciones del API de windows.
; El API usa eax para retornar valores y, en consecuencia, tampoco lo preserva.
; ----------------------------------------------------------------------
; En un invoke, para pasar como parmetro la direccin de una variable (un apuntador a la
; variable) y no su valor, se debe escribir ADDR nombre-variable

  principal proc uses ebx ebp esi edi

		invoke StdOut, addr NOMBRE_ARCHIVO
		
    ;Crea hola.txt en escritura.
    ;El archivo NO debe existir; si no, reporta error.
    invoke openFile, addr nombreArchivo, GENERIC_WRITE, CREATE_NEW
    
    cmp eax, INVALID_HANDLE_VALUE  ;Error al abrir el archivo
    jne escribir
      mov eax, offset MAL_ARCHIVO
      jmp imprimirError
    escribir:
		mov archivo, eax  ;Guardar apuntador a descriptor del archivo

		invoke StdOut, addr ARCHIVO_OK

    ;Escribir "Hola Mundo en el archivo"
		invoke WriteFile, archivo, ADDR HOLA, 10, addr bytesLeidos, NULL
		
		;Cerrar el archivo
		invoke CloseHandle, archivo
		
		;Espera para que el usuario pueda revisar el archivo hola.txt
		invoke StdOut, addr MIRAR_ARCHIVO
		invoke StdIn, addr basura, 4

    ;Abre otra vez hola.txt. Esta vez en lectura-escritura.
    ;El archivo debe existir; si no, reporta error.
    invoke openFile, addr nombreArchivo, ( GENERIC_READ OR GENERIC_WRITE ), OPEN_EXISTING
    cmp eax, INVALID_HANDLE_VALUE  ;Error al abrir el archivo
    jne leerEscribir
      mov eax, offset MAL_ARCHIVO
      jmp imprimirError
    leerEscribir:
		mov archivo, eax  ;Guardar apuntador a descriptor del archivo

    ;posicionarse en el quinto caracter del archivo
		invoke SetFilePointer, archivo, 5, NULL, FILE_BEGIN
		;Leer 5 caracteres desde ah. Es decir, lee la palabra "mundo"
		invoke ReadFile, archivo, addr bufferIO, 5, addr bytesLeidos, NULL
		;Volver al comienzo del archivo
		invoke SetFilePointer, archivo, 0, NULL, FILE_BEGIN
		;Escribir la cadena ahi (escribimos "mundo" encima de "hola "; en el archivo debe quedar "mundomundo").
		invoke WriteFile, archivo, addr bufferIO, 5, addr bytesLeidos, NULL

    jmp finPrincipal
    
		imprimirError:
		push eax
		invoke StdOut, addr ERROR
		pop eax
		invoke StdOut, eax
		
		finPrincipal:
    ;--------------  RETORNO A WINDOWS, FIN DEL PROGRAMA PRINCIPAL ------------------
    invoke ExitProcess, NULL  ;Cdigo de retorno; 0 = terminacin normal

  principal endp

end principal

