; ---------------------------------- ATENCIN ----------------------------------
; SI DESEA MODIFICAR ESTE ARCHIVO, INFRMESE BIEN SOBRE LOS CAMBIOS QUE REALICE
; ------------------------------------------------------------------------------

.NOLIST

; ATENCION:
; Las macros y subrutinas que se encuentran en este archivo suponen que las cadenas de
; caracteres siguen las convenciones de C: una secuencia de caracteres terminada por el
; carcter nulo (0 o NULL).

; CONSTANTES:
   CR             EQU  0DH	; ASCII Carriage Return
   LF             EQU  0AH	; ASCII Line Feed
   HT             EQU  09H	; ASCII Horizontal Tab
;  NULL		Apuntador nulo. Se encuentra en "windows.inc"

; Las siguientes constantes se usan en algunas de las rutinas.
.CONST
   _signoMenos BYTE '-', 0
   _signoMas BYTE '+', 0
   _constante10 WORD 10
   _flotanteEntero BYTE "%ld.",0
   _flotanteFraccion BYTE "%ld",0

.CODE

;*************************** BORRAR PANTALLA ****************************
; Borra la pantalla y pone el cursor en la coordenada (0,0) (esquina superior izquierda).
; Se encuentra en "masm32.inc"; para usarla es necesario incluir "masm32.lib".
; Invocacin:
;	FUNCION
;	invoke ClearScreen

;*************************** POSICIONAR CURSOR ****************************
; Pone el cursor en una coordenada (x,y) de la pantalla (columna, fila).
; Se encuentra en "masm32.inc"; es necesario incluir "masm32.lib".
; Invocacin:
;	FUNCION		PARMETROS		DESCRIPCIN
;	invoke locate,	x:DWORD,		Nmero de la columna
;				y:DWORD		Nmero de la fila

;*************************** LEER TECLADO ****************************
; Lee caracteres hasta que se d <enter>; incluye el CR y el LF; no pone el caracter nulo al final.
; Retorna el nmero de caracteres ledos en eax.
; Se encuentra en "masm32.inc"; es necesario incluir "masm32.lib".
; Invocacin:
;	FUNCION		PARMETROS				DESCRIPCIN
;	invoke StdIn, 	direccionBuffer: DWORD,		Apuntador a la zona de memoria donde se leen los caracteres
;			  	longitudBuffer: DWORD		Tamao de la zona de memoria donde se leen los caracteres

;*************************** ESCRIBIR EN PANTALLA ****************************
; Escribe los caracteres de la cadena hasta encontrar el carcter nulo.
; Se encuentra en "masm32.inc"; es necesario incluir "masm32.lib".
; Invocacin:
;	FUNCION		PARMETROS				DESCRIPCIN
;	invoke StdOut,	direccionBuffer: DWORD		Apuntador a la cadena de caracteres

;*************************** LEER NUMERO DEL TECLADO ****************************
; Lee un nmero, en la base indicada,  del teclado.
; Si la base es negativa, denota que los nmeros pueden tener signo; si no, son sin signo.
; En cualquier caso, se toma como base el valor absoluto de la base.
; Si la base es cero o uno, retorna cero.
; No controla si el nmero excede 32 bits.
; Se salta los caracteres no alfanumricos; procesa los alfanumericos, y se detiene al
; encontrar uno no alfanumerico o mayor que la base, el cual es eliminado.
; Usa StdIn, as que necesita "masm32.inc"; e incluir "masm32.lib".
; Retorna el valor en EAX.
; Invocacin:
;	FUNCION			PARMETROS		DESCRIPCIN
;	invoke readNumber, 	laBase: SDWORD	Base de numeracin
readNumber PROC USES ebx esi, laBase: SDWORD
   LOCAL laCadenaNumero[4]: BYTE
   LOCAL elSigno: SDWORD

   mov ebx, 0
   mov DWORD PTR laCadenaNumero, 0
   lea esi, laCadenaNumero
   mov elSigno, 1

   .REPEAT
	leerCaracterPrevio:
	  invoke StdIn, esi, 1
	  movzx eax, BYTE PTR [esi]

	  cmp al, _signoMenos
	  jne revisarSignoMas
	    neg elSigno
	    jmp leerCaracterPrevio

	  revisarSignoMas:
	cmp al, _signoMas
	je leerCaracterPrevio

	call isAlphaNumeric
   .UNTIL ( SDWORD PTR eax >= 0 )

   .IF ( laBase < 0 )
      neg laBase
   .ELSE
      mov elSigno, 1
   .ENDIF

   .WHILE ( SDWORD PTR eax < laBase && SDWORD PTR eax >= 0 )
      imul ebx, laBase
      add ebx, eax

	leerCaracter:
         invoke StdIn, esi, 1
         movzx eax, BYTE PTR [esi]
	cmp al, CR
	je leerCaracter      ; Para eliminar el LF

	call isAlphaNumeric
   .ENDW

   imul ebx, elSigno
   mov eax, ebx

  ret

readNumber ENDP

; Retorna, en eax, el valor numrico del dgito carcter recibido en eax mismo.
; Si el carcter no es un dgito, retorna -1.
isDigit PROC

   .IF ( al <= '9' && al >= '0' )
      sub eax, '0'
   .ELSE
      mov eax, -1
   .ENDIF

   ret

isDigit ENDP

; Retorna, en eax, el valor numrico (desde 10) del carcter alfabtico recibido en eax.
; Si el carcter no es alfabtico, retorna -1.
isAlpha PROC

   and al, 5FH
   .IF ( al <= 'Z' && al >= 'A' )
      sub eax, 'A'-10
   .ELSE
      mov eax, -1
   .ENDIF

   ret

isAlpha ENDP

; Retorna, en eax, el valor numrico del carcter alfanumrico recibido en eax.
; Si el carcter no es alfanumrico, retorna -1.
isAlphaNumeric PROC

   push eax
   call isDigit
   cmp eax, 0
   jge vaciarPila
      pop eax
	call isAlpha
	jmp finIsAlphaNumeric
   vaciarPila:
      add esp, 4

   finIsAlphaNumeric:
   ret

isAlphaNumeric ENDP

;*************************** ESCRIBIR UN NUMERO EN LA PANTALLA ****************************
; Escribe un nmero, en la base indicada, en la pantalla.
; Si la base es negativa, los nmeros se escriben con signo; si no, se escriben sin signo.
; En cualquier caso, se toma como base el valor absoluto de la base.
; Si la base es cero o uno, escribe cero.
; Usa StdOut, as que necesita "masm32.inc"; e incluir "masm32.lib".
; Invocacin:
;	FUNCION			PARMETROS		DESCRIPCIN
;	invoke printNumber,	laBase: DWORD,	Base de numeracin
;					elNumero: DWORD	Nmero que se desea imprimir
printNumber PROC  USES eax ebx edx, laBase: DWORD, elNumero: DWORD

   mov eax, elNumero
   mov ebx, laBase

   .IF ( SDWORD PTR ebx < -1 )
      neg ebx
      .IF ( SDWORD PTR eax < 0 )
         invoke StdOut, ADDR _signoMenos
         mov eax, elNumero
         neg eax
      .ENDIF
   .ELSEIF ( SDWORD PTR ebx < 2 )
      mov eax, 0
      mov ebx, 2
   .ENDIF

   call printDigit

   ret

printNumber ENDP

; Escribe en pantalla los dgitos de un nmero positivo.
; Recibe el nmero en eax. En ebx recibe la base de numeracin.
; Usa StdOut, as que necesita "masm32.inc"; e incluir "masm32.lib".
printDigit PROC
   LOCAL elDigito[4]: BYTE

   mov DWORD PTR elDigito, 0

   .IF ( eax >= ebx )
      mov edx, 0
      div ebx
      push edx
      call printDigit 
      pop eax
   .ENDIF

   .IF ( al < 10 )
      add  al, '0'
   .ELSE
      add  al, 'A'-10
   .ENDIF
   mov elDigito, al
   invoke StdOut, ADDR elDigito

   ret

printDigit ENDP

;*************************** EQUIVALENTE A PRINTF ****************************
; Similar a printf de C: recibe una cadena de formato y unos valores para imprimir. Invoca
; la funcin wvsprintf de Windows, e imprime el buffer que esta retorna.
; Parmetros: formato: DWORD, y una secuencia de parmetros, acorde con el formato, todos
; de tamao DWORD.
; Usa wvsprintf, as que necesita "user32.inc"; e incluir "user32.lib".
; Retorna en eax el nmero de caracteres impresos.
; Invocacin:
;	FUNCION			PARMETROS		DESCRIPCIN
;	invoke printf, 		elFormato,		Apuntador a la cadena de caracteres con el formato
;					p1, ..., pn		Valores que se desea escribir.
; La cadena de formato describe la forma en que se imprimir cada uno de los restantes
; parmetros. Las especificaciones de formato empiezan con el caracter %.
; printf imprime los caracteres de la cadena hasta encontrar un %, entonces toma el primer
; argumento despus del formato, lo imprime segn lo indicado por la especificacin de
; formato, y continua imprimiendo la cadena de formato de la misma manera.
; La sintaxis de las especificaciones de formato es:
;			%[-][#][0][ancho][.precisin]tipo
; El ancho es el tamao mnimo del campo donde se imprimir el parmetro. Si lo impreso es
; menor, se rellena el campo; si es mayor, o si no se especifica ancho, se imprimen todos
; los caracteres.
; El relleno es con blancos a menos que se especifique el caracter 0, en cuyo caso se
; rellena con ceros. El relleno es a la izquierda a menos que se especifique el caracter -,
; en cuyo caso se hace a la derecha.
; El caracter # hace que se anteponga 0x a los valores hexadecimales.
; Para los nmeros, la precisin define el mnimo nmero de dgitos que se imprimir. Si
; son menos, se completan con ceros a la izquierda; si son ms, se imprimen todos. Si no se
; especifica precisin, se supone 1.
; Para las cadenas, la precisin define el mximo nmero de caracteres que se imprimir.
; El tipo indica cmo se debe interpretar el parmetro (de qu tipo es):
; c		Caracter.
; d		Entero decimal con signo.
; i		Igual a d.
; ld		Entero largo decimal con signo.
; li		Igual a ld.
; lu		Entero largo decimal sin signo.
; lx,lX	Entero largo hexadecimal (con X aparece en maysculas).
; s		Cadena de caracteres.
; u		Entero sin signo.
; x, X	Entero hexadecimal (con X aparece en maysculas).
; Si aparece cualquier otro caracter, se imprime ese mismo caracter.
printf PROC C elFormato: DWORD, losParametros: VARARG
   LOCAL elBuffer[80]: BYTE

   invoke wvsprintf, ADDR elBuffer, elFormato, ADDR losParametros
   invoke StdOut, ADDR elBuffer

   ret

printf ENDP

;*************************** ESCRIBIR NUMERO FLOTANTE EN PANTALLA ****************************
; Imprime un flotante simple.
; Usa printf, as que necesita "user32.inc"; e incluir "user32.lib".
; Invocacin:
;	FUNCION			PARMETROS			DESCRIPCIN
;	invoke printFloat,	elFlotante: REAL4		Nmero flotante que se desea escribir
printFloat PROC USES ecx, elFlotante: REAL4
   LOCAL elDigito: DWORD
   LOCAL controlWord: DWORD

   finit

   fld elFlotante
   ftst
   fstsw ax
   sahf
   jnc esPositivo
	fchs
	invoke StdOut, ADDR _signoMenos
   esPositivo:
	
   fstcw WORD PTR controlWord
   fwait
   or controlWord, 110000000000B
   fldcw WORD PTR controlWord

   fld st
   frndint
   fist elDigito

   and controlWord, 001111111111B
   fldcw WORD PTR controlWord

   fsub

   invoke printf, ADDR _flotanteEntero, elDigito

   mov ecx, 12
   siguienteDigito:
	fimul _constante10

	or controlWord, 110000000000B
 	fldcw WORD PTR controlWord

	fld st
	frndint
	fist elDigito

	and controlWord, 001111111111B
 	fldcw WORD PTR controlWord

	fsub

	push ecx
	invoke printf, ADDR _flotanteFraccion, elDigito
	pop ecx
   loop siguienteDigito

   ret

printFloat ENDP


;*************************** MANEJO DE ARCHIVOS ****************************

;*************************** ABRIR UN ARCHIVO ****************************
; Abre o crea un archivo con el nombre dado como parametro.
; Retorna en eax la manija del archivo abierto.
; Retorna INVALID_HANDLE_VALUE (-1) si falla.
; Usa CreateFile, as que necesita "kernel32.inc"; e incluir "kernel32.lib".
; Invocacion:
;	FUNCION		PARMETROS				DESCRIPCIN
;	invoke openFile	lpFileName:DWORD, 		Apuntador al nombre del archivo
;				DesiredAccess:DWORD,		GENERIC_READ: para abrirlo en entrada
;						    			GENERIC_WRITE: para abrirlo en salida
;		 		CreationDistribution:DWORD	CREATE_NEW: crea el archivo. Si ya existe, falla.
;						    			CREATE_ALWAYS: crea el archivo. Si ya existe, sobre escribe.
;						    			OPEN_EXISTING: abre el archivo. Si no existe, falla.
;						    			OPEN_ALWAYS: abre el archivo, si existe. Si no, lo crea (CREATE_NEW).
;						    			TRUNCATE_EXISTING: abre el archivo y trunca el contenido a 0 bytes. Falla si no existe. 
openFile PROC lpFileName: DWORD, DesiredAccess: DWORD, CreationDistribution: DWORD

   invoke CreateFile, lpFileName, DesiredAccess, 0, NULL, CreationDistribution, FILE_ATTRIBUTE_NORMAL, NULL

   ret

openFile ENDP

;*************************** LEER DE UN ARCHIVO ****************************
; Lee una secuencia de bytes en el archivo indicado.
; Necesita "kernel32.inc"; e incluir "kernel32.lib".
; Retorna 0 en eax si falla.
; Invocacion:
;	FUNCION		PARMETROS			DESCRIPCIN
;	invoke ReadFile,	hFile:DWORD,		Manija del archivo
;				pMemory:DWORD,		Apuntador al buffer en memoria
;				numberBytes:DWORD,	Numero de bytes para leer	
;				lpSizeReadWrite:DWORD,	Apuntador a variable que contendr el nmero de bytes efectivamente leidos
;			     NULL

;*************************** ESCRIBIR EN UN ARCHIVO ****************************
; Escribe una secuencia de bytes en el archivo indicado.
; Necesita "kernel32.inc"; e incluir "kernel32.lib".
; Retorna 0 en eax si falla. El fin de arechivo se indica con eax diferente de cero, y nmero de byte leidos en cero
; Invocacion:
;	FUNCION		PARMETROS			DESCRIPCIN
;	invoke WriteFile, hFile:DWORD,		Manija del archivo
;			      pMemory:DWORD,		Apuntador al buffer en memoria
;			      numberBytes:DWORD,	Numero de bytes para escribir	
;			      lpSizeReadWrite:DWORD,	Apuntador a variable que contendr el nmero de bytes efectivamente leidos
;			      NULL

;*************************** CERRAR UN ARCHIVO ****************************
; Cierra el archivo indicado.
; Necesita "kernel32.inc"; e incluir "kernel32.lib".
; Invocacion:
;	FUNCION			PARMETROS			DESCRIPCIN
;	invoke CloseHandle,	hFile:DWORD		Manija del archivo

.LIST
